
#ifndef _INCLUDED_DCMD_DRIVER_API_H_
#define _INCLUDED_DCMD_DRIVER_API_H_

#include <devctl.h>

typedef enum {
	INPUT, OUTPUT
} dir_t;

//CONFIG part

typedef struct {
	char id[15];
	char next;
} msg_hdr_t;

typedef struct {
	msg_hdr_t	hdr;
	ushort_t	version;
	ushort_t	n_di, n_do, n_ai, n_ao;
	uchar_t		n_bpc;
	uchar_t		max_ai_res, max_ao_res;
} dcmd_config_t;

// AI/O part

typedef struct {
	msg_hdr_t	hdr;
    int			ch;
    int			value;
} dcmd_ch_data_t;

typedef struct {
	msg_hdr_t	hdr;
	int			n;
	/*int		data[n];*/
} dcmd_n_ch_data_t;


#define DCMD_GET_CONFIG				__DIOTF(_DCMD_MISC, 0x10, dcmd_config_t)

#define DCMD_GET_CH_DATA			__DIOTF(_DCMD_MISC, 0x20, dcmd_ch_data_t)
#define DCMD_GET_N_CH_DATA			__DIOTF(_DCMD_MISC, 0x21, dcmd_n_ch_data_t)

#define DCMD_SET_CH_DATA			__DIOT (_DCMD_MISC, 0x30, dcmd_ch_data_t)
#define DCMD_SET_N_CH_DATA			__DIOT (_DCMD_MISC, 0x31, dcmd_n_ch_data_t)

#endif

